# Convert selected points to raster
# Focal Statistics
import arcpy
from arcpy.sa import *
#define workspace
Workspace = "E:\\temp\\NewIdea\\paper\\Paper\\MajorRevisionData\\DEM\\DEM_Process\\"
OutSelect = Workspace + "Result_Select"
OutRaster = Workspace + "Result_Raster"
#list raster classes
arcpy.env.workspace = OutSelect
fcs = arcpy.ListFeatureClasses()
#convert DEM points to raster and apply focal statistics 
for fc in fcs:
    if arcpy.Exists(OutRaster + "\\Focal" + "R" + str(fc[:-4]) + ".tif"):
        print("Focal" + str(fc[:-4]) + ".tif" + " already exists...skipped")
    else:
        print("Processing " + str(fc))
        arcpy.env.workspace = OutRaster
        arcpy.PointToRaster_conversion(Workspace + "Result_Select\\" + str(fc),
                                       "grid_code", "R" + str(fc[:-4]) + ".tif", "Mean", "", 10)
        outFocalStatistics = FocalStatistics("R" + str(fc[:-4]) + ".tif", "", "MEAN", "")
        print("R" + str(fc[:-4]) + ".tif" + " completed")
        outFocalStatistics.save("Focal" + "R" + str(fc[:-4]) + ".tif")
        print("Focal" + str(fc[:-4]) + ".tif" + " completed")
# Delete old rasters
arcpy.env.workspace = OutRaster
rasters = arcpy.ListRasters("*", "tif")
for raster in rasters:
    if raster.startswith('R'):
        arcpy.Delete_management(raster)

# Save the output
print("Result_Raster completed, please run the next file: Result_Polygon")